package com.elephant.framework.galaxy.aroad.response;

import com.elephant.framework.galaxy.aroad.constant.CommonConstants;
import com.elephant.framework.galaxy.aroad.exception.CommonError;
import lombok.*;
import lombok.experimental.Accessors;

import java.io.Serializable;

/**
 * @Description 全局统一返回对象
 * @auther wangjian
 * @create 2019-02-18 15:23
 */

@Builder
@ToString
@Accessors(chain = true)
@AllArgsConstructor
public class R<T> implements Serializable {

    private static final long serialVersionUID = 1L;

    @Getter
    @Setter
    private int code = CommonConstants.SUCCESS;
    // success 返回正常数据json
    // fail 返回通用的错误码

    @Getter
    @Setter
    private String msg = "success";

    @Getter
    @Setter
    private T data;

    public R() {
        super();
    }

    public R(T data) {
        super();
        this.data = data;
    }

    public R(T data, String msg) {
        super();
        this.data = data;
        this.msg = msg;
    }

    public R(int code, String msg) {
        super();
        this.code = code;
        this.msg = msg;
    }

    public R(Throwable e) {
        super();
        this.msg = e.getMessage();
        this.code = CommonConstants.FAIL;
    }

    public R(CommonError e) {
        super();
        this.msg = e.getErrorMessage();
        this.code = e.getErrorCode();
    }
}
